# coding: utf-8

"""
    Sparks OpenAPI

    Generated documentation for the Logicdrop Sparks API and OpenAPI clients.  Logicdrop Sparks lets users build rules, analyze data, and automate documents.  Use it to make decisions faster, generate documents better, and learn from your data.  ### Documentation - [User Documentation](https://docs.logicdrop.com)  ### Modules - [Sparks Compute](https://docs.logicdrop.com/rules/introduction) - [Sparks Decision Tables](https://docs.logicdrop.com/rules/authoring-decision-tables) - [Sparks Documents](https://docs.logicdrop.com/documents/introduction)  ### Clients - [OpenAPI Clients](https://docs.logicdrop.com/development/sample-clients)  ### Security - [Authorizing API Requests](https://docs.logicdrop.com/development/authorization)   # noqa: E501

    The version of the OpenAPI document: v_VERSION_._BUILD_
    Contact: support@logicdrop.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from logicdrop.sparks.openapi.configuration import Configuration


class DesignerOptions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'debug': 'bool',
        'threshold': 'int',
        'content': 'bool',
        'tracing': 'bool',
        'expand': 'bool',
        'dictionary': 'bool'
    }

    attribute_map = {
        'debug': 'debug',
        'threshold': 'threshold',
        'content': 'content',
        'tracing': 'tracing',
        'expand': 'expand',
        'dictionary': 'dictionary'
    }

    def __init__(self, debug=True, threshold=None, content=True, tracing=True, expand=False, dictionary=True, local_vars_configuration=None):  # noqa: E501
        """DesignerOptions - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._debug = None
        self._threshold = None
        self._content = None
        self._tracing = None
        self._expand = None
        self._dictionary = None
        self.discriminator = None

        if debug is not None:
            self.debug = debug
        if threshold is not None:
            self.threshold = threshold
        if content is not None:
            self.content = content
        if tracing is not None:
            self.tracing = tracing
        if expand is not None:
            self.expand = expand
        if dictionary is not None:
            self.dictionary = dictionary

    @property
    def debug(self):
        """Gets the debug of this DesignerOptions.  # noqa: E501

        Enable debugging?  # noqa: E501

        :return: The debug of this DesignerOptions.  # noqa: E501
        :rtype: bool
        """
        return self._debug

    @debug.setter
    def debug(self, debug):
        """Sets the debug of this DesignerOptions.

        Enable debugging?  # noqa: E501

        :param debug: The debug of this DesignerOptions.  # noqa: E501
        :type: bool
        """

        self._debug = debug

    @property
    def threshold(self):
        """Gets the threshold of this DesignerOptions.  # noqa: E501

        Maximum rules to fire  # noqa: E501

        :return: The threshold of this DesignerOptions.  # noqa: E501
        :rtype: int
        """
        return self._threshold

    @threshold.setter
    def threshold(self, threshold):
        """Sets the threshold of this DesignerOptions.

        Maximum rules to fire  # noqa: E501

        :param threshold: The threshold of this DesignerOptions.  # noqa: E501
        :type: int
        """

        self._threshold = threshold

    @property
    def content(self):
        """Gets the content of this DesignerOptions.  # noqa: E501

        Include ruleset content?  # noqa: E501

        :return: The content of this DesignerOptions.  # noqa: E501
        :rtype: bool
        """
        return self._content

    @content.setter
    def content(self, content):
        """Sets the content of this DesignerOptions.

        Include ruleset content?  # noqa: E501

        :param content: The content of this DesignerOptions.  # noqa: E501
        :type: bool
        """

        self._content = content

    @property
    def tracing(self):
        """Gets the tracing of this DesignerOptions.  # noqa: E501

        Enable event tracing?  # noqa: E501

        :return: The tracing of this DesignerOptions.  # noqa: E501
        :rtype: bool
        """
        return self._tracing

    @tracing.setter
    def tracing(self, tracing):
        """Sets the tracing of this DesignerOptions.

        Enable event tracing?  # noqa: E501

        :param tracing: The tracing of this DesignerOptions.  # noqa: E501
        :type: bool
        """

        self._tracing = tracing

    @property
    def expand(self):
        """Gets the expand of this DesignerOptions.  # noqa: E501

        Expand data in events?  # noqa: E501

        :return: The expand of this DesignerOptions.  # noqa: E501
        :rtype: bool
        """
        return self._expand

    @expand.setter
    def expand(self, expand):
        """Sets the expand of this DesignerOptions.

        Expand data in events?  # noqa: E501

        :param expand: The expand of this DesignerOptions.  # noqa: E501
        :type: bool
        """

        self._expand = expand

    @property
    def dictionary(self):
        """Gets the dictionary of this DesignerOptions.  # noqa: E501

        Include flattened data  # noqa: E501

        :return: The dictionary of this DesignerOptions.  # noqa: E501
        :rtype: bool
        """
        return self._dictionary

    @dictionary.setter
    def dictionary(self, dictionary):
        """Sets the dictionary of this DesignerOptions.

        Include flattened data  # noqa: E501

        :param dictionary: The dictionary of this DesignerOptions.  # noqa: E501
        :type: bool
        """

        self._dictionary = dictionary

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DesignerOptions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DesignerOptions):
            return True

        return self.to_dict() != other.to_dict()
