# coding: utf-8

"""
    Sparks OpenAPI

    Generated documentation for the Logicdrop Sparks API and OpenAPI clients.  Logicdrop Sparks lets users build rules, analyze data, and automate documents.  Use it to make decisions faster, generate documents better, and learn from your data.  ### Documentation - [User Documentation](https://docs.logicdrop.com)  ### Modules - [Sparks Compute](https://docs.logicdrop.com/rules/introduction) - [Sparks Decision Tables](https://docs.logicdrop.com/rules/authoring-decision-tables) - [Sparks Documents](https://docs.logicdrop.com/documents/introduction)  ### Clients - [OpenAPI Clients](https://docs.logicdrop.com/development/sample-clients)  ### Security - [Authorizing API Requests](https://docs.logicdrop.com/development/authorization)   # noqa: E501

    The version of the OpenAPI document: v_VERSION_._BUILD_
    Contact: support@logicdrop.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from logicdrop.sparks.openapi.configuration import Configuration


class ProcessorRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'project': 'str',
        'ruleset': 'str',
        'version': 'str',
        'properties': 'dict(str, object)',
        'inputs': 'list[dict(str, object)]',
        'outputs': 'list[str]',
        'options': 'ComputeOptions'
    }

    attribute_map = {
        'project': 'project',
        'ruleset': 'ruleset',
        'version': 'version',
        'properties': 'properties',
        'inputs': 'inputs',
        'outputs': 'outputs',
        'options': 'options'
    }

    def __init__(self, project=None, ruleset=None, version=None, properties=None, inputs=None, outputs=None, options=None, local_vars_configuration=None):  # noqa: E501
        """ProcessorRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._project = None
        self._ruleset = None
        self._version = None
        self._properties = None
        self._inputs = None
        self._outputs = None
        self._options = None
        self.discriminator = None

        if project is not None:
            self.project = project
        if ruleset is not None:
            self.ruleset = ruleset
        if version is not None:
            self.version = version
        if properties is not None:
            self.properties = properties
        if inputs is not None:
            self.inputs = inputs
        if outputs is not None:
            self.outputs = outputs
        if options is not None:
            self.options = options

    @property
    def project(self):
        """Gets the project of this ProcessorRequest.  # noqa: E501

        Project name  # noqa: E501

        :return: The project of this ProcessorRequest.  # noqa: E501
        :rtype: str
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this ProcessorRequest.

        Project name  # noqa: E501

        :param project: The project of this ProcessorRequest.  # noqa: E501
        :type: str
        """

        self._project = project

    @property
    def ruleset(self):
        """Gets the ruleset of this ProcessorRequest.  # noqa: E501

        Ruleset name  # noqa: E501

        :return: The ruleset of this ProcessorRequest.  # noqa: E501
        :rtype: str
        """
        return self._ruleset

    @ruleset.setter
    def ruleset(self, ruleset):
        """Sets the ruleset of this ProcessorRequest.

        Ruleset name  # noqa: E501

        :param ruleset: The ruleset of this ProcessorRequest.  # noqa: E501
        :type: str
        """

        self._ruleset = ruleset

    @property
    def version(self):
        """Gets the version of this ProcessorRequest.  # noqa: E501

        Ruleset version  # noqa: E501

        :return: The version of this ProcessorRequest.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this ProcessorRequest.

        Ruleset version  # noqa: E501

        :param version: The version of this ProcessorRequest.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def properties(self):
        """Gets the properties of this ProcessorRequest.  # noqa: E501

        User properties  # noqa: E501

        :return: The properties of this ProcessorRequest.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this ProcessorRequest.

        User properties  # noqa: E501

        :param properties: The properties of this ProcessorRequest.  # noqa: E501
        :type: dict(str, object)
        """

        self._properties = properties

    @property
    def inputs(self):
        """Gets the inputs of this ProcessorRequest.  # noqa: E501

        Inputs to process  # noqa: E501

        :return: The inputs of this ProcessorRequest.  # noqa: E501
        :rtype: list[dict(str, object)]
        """
        return self._inputs

    @inputs.setter
    def inputs(self, inputs):
        """Sets the inputs of this ProcessorRequest.

        Inputs to process  # noqa: E501

        :param inputs: The inputs of this ProcessorRequest.  # noqa: E501
        :type: list[dict(str, object)]
        """

        self._inputs = inputs

    @property
    def outputs(self):
        """Gets the outputs of this ProcessorRequest.  # noqa: E501

        Outputs to return (by name)  # noqa: E501

        :return: The outputs of this ProcessorRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._outputs

    @outputs.setter
    def outputs(self, outputs):
        """Sets the outputs of this ProcessorRequest.

        Outputs to return (by name)  # noqa: E501

        :param outputs: The outputs of this ProcessorRequest.  # noqa: E501
        :type: list[str]
        """

        self._outputs = outputs

    @property
    def options(self):
        """Gets the options of this ProcessorRequest.  # noqa: E501


        :return: The options of this ProcessorRequest.  # noqa: E501
        :rtype: ComputeOptions
        """
        return self._options

    @options.setter
    def options(self, options):
        """Sets the options of this ProcessorRequest.


        :param options: The options of this ProcessorRequest.  # noqa: E501
        :type: ComputeOptions
        """

        self._options = options

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProcessorRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ProcessorRequest):
            return True

        return self.to_dict() != other.to_dict()
